{{- $team := site.Data.public.team -}}
{{- $allDeptDivisions := slice }}
{{- range site.Data.public.team }}
  {{- range .departments }}
    {{- $allDeptDivisions = $allDeptDivisions | append . }}
  {{- end }}
  {{- if .division }}
    {{- $allDeptDivisions = $allDeptDivisions | append .division }}
  {{- end }}
{{- end }}
{{- $allDeptDivisions = uniq $allDeptDivisions }}

<div class="my-6 g-2 row">
  <div class="col-auto">
  <label for="department" class="h4 form-label">Filter by Division/Department:</label>
  </div>
  <div class="col-auto">
  <select class="form-select" id="department">
      <option value="all" selected>All Divisions and Departments</option>
      {{- range (sort $allDeptDivisions) }}
        {{- if . }}
          <option value="{{ . }}">{{ . }}</option>
        {{- end }}
      {{- end }}
    </select>
  </div>
</div>

<p>&nbsp;</p>

<div class="container">
  <div class="row row-cols-4">
  {{ range $team }}
  {{- if eq .name .job_title }}
    {{- continue }}
  {{- end }}
  {{ $picture := "https://about.gitlab.com/images/gitlab-logo-extra-whitespace.png" }}
  {{ if not (eq .picture "../gitlab-logo-extra-whitespace.png") }}
    {{ $suf := printf ".%s" (index (last 1 (strings.Split .picture ".")) 0) }}
    {{ $picture = printf "https://about.gitlab.com/images/team/%s-crop.jpg" (strings.TrimSuffix $suf .picture) }}
  {{ end }}

  <div class="col col-6 col-md-4 col-lg-3 text-center member" id="{{.gitlab | anchorize }}" data-departments="{{ .departments | append .division | uniq | jsonify }}">
      <a href="#" data-bs-toggle="modal" data-bs-target="#{{.gitlab | anchorize}}-modal" >
          <img src="{{$picture}}" alt="{{.name}}" class="member-img" width="120" height="120" loading="lazy">
      </a>
      <p class="h4">{{.name}}</p>
      <p>{{ .role | safeHTML }}</p>
      <p>
          <a href="https://gitlab.com/{{.gitlab}}"><i class="m-1 fa-brands fa-gitlab fa-2xl"></i></a>
          {{ with .linkedin }}
          <a href="https://www.linkedin.com/in/{{.}}"><i class="m-1 fa-brands fa-linkedin fa-2xl"></i></a>
          {{ end }}
          {{ with .twitter }}
          <a href="https://twitter.com/{{.}}"><i class="m-1 fa-brands fa-twitter fa-2xl"></i></a>
          {{ end }}
          {{ with .mastodon }}
            {{ $mastodonLink := . }}
            {{ $displayLink := . }}

            {{ if not (hasPrefix . "http") }}
              {{ if hasPrefix . "@" }}
                {{ $parts := split (trim . "@") "@" }}
                {{ if eq (len $parts) 2 }}
                  {{ $mastodonLink = printf "https://%s/@%s" (index $parts 1) (index $parts 0) }}
                  {{ $displayLink = . }}
                {{ else }}
                  {{ $mastodonLink = printf "https://%s" . }}
                {{ end }}
              {{ else }}
                {{ $mastodonLink = printf "https://%s" . }}
              {{ end }}
            {{ end }}

            <a href="{{ $mastodonLink }}"><i class="m-1 fa-brands fa-mastodon fa-2xl"></i></a>
          {{ end }}
      </p>
  </div>
  <div class="modal modal-lg" id="{{.gitlab | anchorize}}-modal" tabindex="-1">
      <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">{{.name}}</h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">
              <div class="container-fluid">
                  <div class="row align-items-center">
                  <div class="col-md-6 text-center">
                    <img src="{{$picture}}" alt="{{.name}}" class="m-4 member-img-color" width="120" height="120" loading="lazy">
                    <p>
                          <a href="https://gitlab.com/{{.gitlab}}"><i class="m-1 fa-brands fa-gitlab fa-2xl"></i></a>
                          {{ with .linkedin }}
                          <a href="https://www.linkedin.com/in/{{.}}"><i class="m-1 fa-brands fa-linkedin fa-2xl"></i></a>
                          {{ end }}
                          {{ with .twitter }}
                          <a href="https://twitter.com/{{.}}"><i class="m-1 fa-brands fa-twitter fa-2xl"></i></a>
                          {{ end }}
                      </p>
                  </div>
                  <div class="col-md-6">
                    {{- with .job_title }}
                    <p><strong>Job Title:</strong> {{ . }}</p>
                    {{- end }}
                    <p><strong>departments:</strong>
                    <ul>{{ range .departments }}<li><a href="/handbook/company/team/?department={{.}}">{{.}}</a></li>{{end}}</ul></p>
                    {{ with .speciality }}
                    <p><strong>Speciality:</strong> {{.}}</p>
                    {{ end }}
                    {{ with .pronouns }}
                    <p><strong>Pronouns:</strong> {{.}}</p>
                    {{end}}
                    {{ with .pronunciation }}
                    <p><strong>Pronunciation:</strong> {{.}}</p>
                    {{end}}
                    {{- with .gitlab }}
                    <p><strong>GitLab Handle:</strong> <a href="https://gitlab.com/{{.}}" target="_blank">{{ . }}</a></p>
                    {{- end }}
                  </div>
                  </div>

              <div class="row">
                  <div class="col">
              {{ with .projects }}
              <hr>
              <p class="h4">Projects:</p>
              <ul>
                  {{ range $k, $v := . }}
                  <li>{{$k}}
                      <ul>
                          {{ if reflect.IsSlice $v }}
                          {{ range $v}}
                          <li>{{.}}</li>
                          {{end}}
                          {{else}}
                          <li>{{$v}}</li>
                          {{end}}
                      </ul>
                  </li>
                  {{end}}
              </ul>
              {{ end }}
              {{ with .story }}
              <hr>
              <p class="h4">Story</p>
              <p>{{ . | markdownify }}</p>
              {{ end }}
                  </div></div>
              </div>
          </div>
          <div class="modal-footer">
            <a href="https://gitlab.com/-/ide/project/gitlab-com/www-gitlab-com/edit/master/-/data/team_members/person/{{ substr .slug 0 1}}/{{.slug}}.yml" class="btn btn-light">
                Edit This Page
            </a>
            <button type="button" class="btn btn-primary" data-bs-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>
    {{- end }}
  </div>
</div>

<script>
    $(document).ready(function(event) {
        if(location.hash) {
          modalName = location.hash.substr(1, location.hash.length - 1) + "-modal";
          if(document.getElementById(modalName)) {
            new bootstrap.Modal(document.getElementById(modalName)).show();
          }
        }
        $('#department').change(function(){
          const url = new URL(location);
          if($('#department').val() === "all") {
            url.searchParams.delete("departmentOrDivision");
            history.pushState({}, "", url);
            $('.member').show()
          } else {
            url.searchParams.set("departmentOrDivision", $(this).val());
            history.pushState({}, "", url);
            $('.member').each(function() {
              const departments = $(this).data("departments")
              if(departments.includes($('#department').val())) {
                $(this).show();
              }
              else {
                $(this).hide();
              }
            })
          }
        })
        let params = (new URL(document.location)).searchParams;
        let departmentOrDivision = params.get("departmentOrDivision");
        if(departmentOrDivision) {
          $('#department').val(departmentOrDivision).change();
        }
    });
</script>

